//
// PS2PC: An Intel x86 emulator for MIPS R5900 (Sony PS2).
// Coded by Mike Tedder / breakpoint - bpoint@parodius.com
// http://ps2pc.parodius.com
//
// This project is released as 'open source'.  You may make any modifications
// or adjustments to the code and submit a patch to be applied to the project.
// See the web page for more details.
//
//-----------------------------------------------------------------------

#include "types.h"

int x86ADD_EbGb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86ADD_EvGv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86ADD_GbEb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86ADD_GvEv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86ADD_ALIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86ADD_eAXIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86ADC_EbGb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86ADC_EvGv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86ADC_GbEb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86ADC_GvEv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86ADC_ALIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86ADC_eAXIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86SUB_EbGb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86SUB_EvGv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86SUB_GbEb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86SUB_GvEv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86SUB_ALIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86SUB_eAXIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86SBB_EbGb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86SBB_EvGv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86SBB_GbEb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86SBB_GvEv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86SBB_ALIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86SBB_eAXIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86INC_eAX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86INC_eCX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86INC_eDX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86INC_eBX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86INC_eSP(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86INC_eBP(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86INC_eSI(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86INC_eDI(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86DEC_eAX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86DEC_eCX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86DEC_eDX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86DEC_eBX(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86DEC_eSP(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86DEC_eBP(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86DEC_eSI(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86DEC_eDI(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86IMUL_GvEvIv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86IMUL_GvEvIb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
